;***************************************************************************
;FUSE- CKSEL3...0=1101	;4   
;CKDIV8=1	;    8 
;SUT1...0=11	; ,    
;CKOUT=1		;Output Clock on CKOUT 
;BODLEVEL3...0=100	; BODLEVEL=4,3 
;EESAVE=0		; EEPROM    
;WDTON=0		;Watchdog Timer  
;SPIEN=0	;!!!    
;DWEN=X		;  ,  
;RSTDISBL=1	;!!!     ,    
.include "tn2313def.inc"
;==========    
.equ INPUT=PD0 	;PD0 - 
.equ RxLED=PD2 	;PD2 -  HL1,     
.equ LED1=PD3 	;PD3 -   HL2
.equ Key1=PD5	;PD5 -  SB2, " "
.equ Key2=PD4	;PD4 -  SB1, " "
;***************************************************************************
;
.equ	SYS_ADDR=0		;The system address   RC-5

.equ	MinBrLevel=0	; 

.equ	MaxBrLevel=40	; 

.equ 	BaseCmdAddr=1	;    EEPROM      


.def	inttemp	=R1		;   RC-5

.def	ref1	=R2		;   RC-5

.def	ref2	=R3		;   RC-5



.def	temp	=R16	; 



.def	timerL	=R17	;   RC-5

.def	timerH	=R18	;   RC-5



.def	system	=R19	;    RC-5   

.def	command	=R20	;    RC-5   



.def	bitcnt	=R21	;   RC-5



.def	EEPromAddr=R22	;  EEPROM      EEPROM

.def	EEPromData=R23	; EEPROM      EEPROM
.def	BrLevel=R24		;,     


;***************************************************************************
;****=============
;***************************************************************************
.macro RxLEDOn	; ,     
		sbi PORTD, RxLED ; 
.endm
.macro RxLEDOff	; ,     
		cbi PORTD, RxLED ; 
.endm
.macro LED1On	;  
		sbi PORTD, LED1 ; 
.endm
.macro LED1Off	;  
		cbi PORTD, LED1 ; 
.endm
;*******************************************************************
;=======================================  
;*******************************************************************
.cseg
.org 0
		rjmp reset
.org OVF0addr
		rjmp TIM0_OVF
.org ACIaddr         ;= 0x00A Analog Comparator Interrupt 
		rjmp ACIint
;------   
.org INT_VECTORS_SIZE+1
;*******************************************************************
;========================    0
;*******************************************************************
TIM0_OVF:	
		push temp; ------- 
		in temp,sreg ; Store SREG
		push temp

		inc	timerL		;Updated every 64us

		inc	inttemp

		brne	TIM0_OVF_exit



		inc	timerH



TIM0_OVF_exit:	
		pop temp;-------- 
		out sreg, temp ; Restore SREG
		pop temp
		reti

;*******************************************************************
;=========================================   
;*******************************************************************
ACIint:
		push temp; ------- 
		in temp,sreg ; Store SREG
		push temp

;=====      ,  
;===== ,      ,   
;----------,      
		cpi	BrLevel, MaxBrLevel
		brne m4010
		;----- ,    1
		ldi temp, (0<<COM1A1)|(0<<COM1A0)|(0<<COM1B1)|(0<<COM1B0)|(0<<WGM11)|(0<<WGM10)
		out TCCR1A, temp
		ldi temp, (0<<ICNC1)|(0<<ICES1)|(0<<WGM13)|(0<<WGM12)|(0<<CS12)|(0<<CS11)|(0<<CS10) 
		out TCCR1B, temp
		sbi	PORTB, PB3	;  
		rjmp ACIint_exit
m4010:
;----------,      
		cpi	BrLevel, MinBrLevel
		brne m4020
		;----- ,    1
		ldi temp, (0<<COM1A1)|(0<<COM1A0)|(0<<COM1B1)|(0<<COM1B0)|(0<<WGM11)|(0<<WGM10)
		out TCCR1A, temp
		ldi temp, (0<<ICNC1)|(0<<ICES1)|(0<<WGM13)|(0<<WGM12)|(0<<CS12)|(0<<CS11)|(0<<CS10) 
		out TCCR1B, temp
		cbi	PORTB, PB3	;  
		rjmp ACIint_exit
m4020:

;===    ,    
;----  
		in temp, ACSR
		sbrc temp, ACO	;    ,    .0
		rjmp No220V
;---------------------   

;--------------  1
		ldi temp, (1<<COM1A1)|(1<<COM1A0)|(0<<COM1B1)|(0<<COM1B0)|(0<<WGM11)|(0<<WGM10)
		out TCCR1A, temp
		ldi temp, (0<<ICNC1)|(0<<ICES1)|(0<<WGM13)|(0<<WGM12)|(0<<CS12)|(0<<CS11)|(1<<CS10) 
		out TCCR1B, temp

;--------    1
		rcall SetTimer1Delay	

		rjmp ACIint_exit


No220V:	;   
;----- ,     1  
		ldi temp, (1<<COM1A1)|(0<<COM1A0)|(0<<COM1B1)|(0<<COM1B0)|(0<<WGM11)|(0<<WGM10)
		out TCCR1A, temp
		ldi temp, (0<<ICNC1)|(0<<ICES1)|(0<<WGM13)|(0<<WGM12)|(0<<CS12)|(0<<CS11)|(0<<CS10) 
		out TCCR1B, temp
;----    1A
		ldi temp, (1<<FOC1A)|(0<<FOC1B)
		out TCCR1C, temp
;-----  1
		ldi temp,0
		out TCNT1H,temp	;   
		out TCNT1L,temp	; 
		rjmp ACIint_exit

ACIint_exit:
		pop temp;-------- 
		out sreg, temp ; Restore SREG
		pop temp
		reti
;********************************************************************

;*========== 

;********************************************************************

reset:	
		ldi  	temp,low(RAMEND)	;Initialize stackpointer

		out	SPL,temp			

;-------- Timer/Counter 0	

		ldi	temp,1		;Timer/Counter 0 clocked at CK

		out	TCCR0,temp



		ldi	temp,1<<TOIE0	;Enable Timer0 overflow interrupt

		out	TIMSK,temp



;------   
		sbi DDRB, PB3	;      1 ( )
		cbi DDRD, INPUT	;      -
		sbi PORTD, INPUT;     -
		cbi DDRD, Key1	;       1
		sbi PORTD,Key1	;        1
		cbi DDRD, Key2	;       2
		sbi PORTD,Key2	;        2
		sbi DDRD, RxLED	;     
		sbi DDRD, LED1	;     

;---  
		ldi temp, (0<<AIN0D)|(1<<AIN1D)	;     AIN1
		out DIDR, temp
;
		ldi temp, (0<<ACD) | (1<<ACBG) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0)
		out ACSR, temp
		sbr temp, (1<<ACIE) ;   
		out ACSR, temp

		sei			;Enable gobal iterrupt


		rcall WDT_Prescaler_Change	; Watchdog Timer'

		sbis	PIND, Key1	;   1,      
		rcall SaveCommand

;-----------------   
		ldi BrLevel, MinBrLevel	
		rcall SetTimer1Delay	

;========================  

main:	
		wdr	; Watchdog Timer

		rcall	detect		;Call RC5 detect routine


		RxLEDOn
		LED1Off


		cpi	system,SYS_ADDR	;Respponds only at the specified address

		brne	release



		andi	command,0x3F	;Remove control bit

		
		RxLEDOff


;===============  
		ldi EEPromAddr, BaseCmdAddr+0	; " "
		rcall EERead
		cp EEPromData, command
		brne m2020
ManualBrUp:
		cpi	BrLevel, MaxBrLevel
		breq CmdExec
		inc BrLevel
		rjmp CmdExec
m2020:
 		ldi EEPromAddr, BaseCmdAddr+1	; " "
		rcall EERead
		cp EEPromData, command
		brne m2030
ManualBrDown:
		cpi	BrLevel, MinBrLevel
		breq CmdExec
		dec BrLevel
		rjmp CmdExec
m2030:
 		ldi EEPromAddr, BaseCmdAddr+2	; " "
		rcall EERead
		cp EEPromData, command
		brne m2040
		ldi	BrLevel, MaxBrLevel
		rjmp CmdExec
m2040:
 		ldi EEPromAddr, BaseCmdAddr+3	; " "
		rcall EERead
		cp EEPromData, command
		brne m2050
		ldi	BrLevel, MinBrLevel
		rjmp CmdExec
m2050:
		rjmp UnSupportedCommand	;  ,    


CmdExec:
;----  ,      
		cpi	BrLevel, MaxBrLevel
		breq m3010
		cpi	BrLevel, MinBrLevel
		breq m3010
		rjmp m3020
m3010:
		LED1On
m3020:
;--------    1
;		rcall SetTimer1Delay	

UnSupportedCommand:
		rjmp	main



release:	;----------      	
		clr	command	
;------------,       1  2
sbis	PIND, Key1	;   1,   
		rjmp ManualBrUp
sbis	PIND, Key2	;   2,   
		rjmp ManualBrDown


		rjmp	main



;********************************************************************

;==========  
;********************************************************************


;********************************************************************

;==  RC-5,    AVR-410
;********************************************************************

;********************************************************************

;* "detect" - RC5 decode routine

;*

;* This subroutine decodes the RC5 bit stream applied on PORTD

;* pin "INPUT". 

;*

;* If successe: The command and system address are

;*		returned in "command" and "system".

;*		Bit 6 of "command" holds the toggle bit.

;*

;* If failed: 	$FF in both "system" and "command"

;*

;* Crystal frequency is 4MHz

;*

;* Number of words:	72

;* Low registers used:	 3

;* High registers used:  6

;* Pointers used:	 0

;********************************************************************

detect:		clr	inttemp

		clr	timerH



detect1:	clr	timerL



detect2:	cpi	timerH,8	;If line not idle within 131ms

		brlo	dl1

		rjmp	fault		;  then exit



dl1:		cpi	timerL,55	;If line low for 3.5ms

		brge	start1		;   then wait for start bit



		sbis	PIND,INPUT	;If line is

		rjmp	detect1		;   low  - jump to detect1

		rjmp	detect2		;   high - jump to detect2





start1:		cpi	timerH,8	;If no start bit detected

		brge	fault		;within 130ms then exit



		sbic	PIND,INPUT	;Wait for start bit

		rjmp	start1





		clr	timerL		;Measure length of start bit

		

start2:		cpi	timerL,17	;If startbit longer than 1.1ms,

		brge	fault		;   exit



		sbis	PIND,INPUT

		rjmp	start2

					;Positive edge of 1st start bit



		mov	temp,timerL	;timer is 1/2 bit time

		clr	timerL



		mov	ref1,temp

		lsr	ref1

		mov	ref2,ref1

		add	ref1,temp	;ref1 = 3/4 bit time

		lsl	temp

		add	ref2,temp	;ref2 = 5/4 bit time





start3:		cp	timerL,ref1	;If high periode St2 > 3/4 bit time

		brge	fault		;   exit



		sbic	PIND,INPUT	;Wait for falling edge start bit 2

		rjmp	start3



		clr	timerL

		ldi	bitcnt,12	;Receive 12 bits

		clr	command

		clr	system





sample:		cp	timerL,ref1	;Sample INPUT at 1/4 bit time

		brlo	sample



		sbic	PIND,INPUT

		rjmp	bit_is_a_1	;Jump if line high





bit_is_a_0:	clc			;Store a '0'

		rol	command

		rol	system



					;Synchronize timing

bit_is_a_0a:	cp	timerL,ref2	;If no edge within 3/4 bit time

		brge	fault		;   exit

		sbis	PIND,INPUT	;Wait for rising edge

		rjmp	bit_is_a_0a	;in the middle of the bit



		clr	timerL

		rjmp	nextbit



bit_is_a_1:	sec			;Store a '1'

		rol	command

		rol	system

					;Synchronize timing

bit_is_a_1a:	cp	timerL,ref2	;If no edge within 3/4 bit time

		brge	fault		;   exit

		sbic	PIND,INPUT	;Wait for falling edge

		rjmp	bit_is_a_1a	;in the middle of the bit



		clr	timerL



nextbit:	dec	bitcnt		;If bitcnt > 0

		brne	sample		;   get next bit





;All bits sucessfully received!

		mov	temp,command	;Place system bits in "system"

		rol	temp

		rol	system

		rol	temp

		rol	system



		bst	system,5	;Move toggle bit

		bld	command,6	;to "command"



					;Clear remaining bits

		andi	command,0b01111111

		andi	system,0x1F



		ret



fault:		ser	command		;Both "command" and "system"

		ser	system		;0xFF indicates failure

		ret
;***************************************************************************
;****=============  EEPROM
;***************************************************************************
;------   EEProm
;--  EEPromAddr   
;----  EEPromData   
EEWrite:
		sbic EECR, EEPE ;,   EEPE 
		rjmp EEWrite    ;  
		cli 		; 
		out EEAR,EEPromAddr 	;   
		out EEDR, EEPromData ;  
		sbi EECR, EEMPE 	;    EEProm
		sbi EECR, EEPE 	;    EEProm
Loop1010:
		sbic EECR, EEPE ;,   EEPE ( )
		rjmp Loop1010    ;  
		sei		; 
ENDEEWrite:
		ldi temp, 0	;   EEPROM
		out EEAR,temp 	;    
		ret
;------   EEProm
;--  EEPromAddr   
;----  EEPromData     EEPROM
EERead:
; Wait for completion of previous write
		sbic EECR,EEWE
		rjmp EERead
		out EEAR, EEPromAddr 	;   
		sbi EECR,EERE
; Read data from data register
		in EEPromData,EEDR
		ret
;***************************************************************************
;==============      EEPROPM
;***************************************************************************
.macro SaveKeyCommand
IsKeyPressed:
		wdr	; Watchdog Timer
		sbic	PIND, Key1	;   1
		rjmp IsKeyPressed

SaveCommand:
		LED1On
;----------     
		wdr	; Watchdog Timer

		rcall	detect		;Call RC5 detect routine


		cpi	system,SYS_ADDR	;Respponds only at the specified address

		brne	SaveCommand


		LED1Off
		andi	command,0x3F	;Remove control bit

;----------        EEPROM
		ldi EEPromAddr, BaseCmdAddr+@0

		mov	EEPromData, command
		rcall EEWrite

.endm

;***************************************************************************
;======      EEPROM
;***************************************************************************
SaveCommand:
		SaveKeyCommand 0	; " "
		SaveKeyCommand 1	; " "
		SaveKeyCommand 2	; " "
		SaveKeyCommand 3	; " "
		ret

;***************************************************************************
;======     1     
;======   BrLevel
;***************************************************************************
SetTimer1Delay:
;--------    1
		mov temp, BrLevel

		subi	temp, MaxBrLevel	
		com	temp
		inc temp	; temp=MaxBrLevel-temp

		lsl temp
		lsl temp	; temp=(MaxBrLevel-temp)*4
					;  ~0.25ms*temp
		cli
		out OCR1AH,temp	;   
		ldi temp,1
		out OCR1AL,temp	; 
		sei
		ret
;***************************************************************************
;===   Watchdog Timer
;***************************************************************************
WDT_Prescaler_Change:
		push temp; ------- 
		in temp,sreg ; Store SREG
		push temp


		cli	; Turn off global interrupt

		wdr	; Reset Watchdog Timer

;-----------Start timed sequence
		in temp, WDTCSR
		ori temp, (1<<WDCE) | (1<<WDE)
		out WDTCSR, temp

; -- Got four cycles to set the new values from here -
; Set new prescaler(time-out) value = 256K cycles (~2 s) WDP3...0=0111
		ldi temp, (1<<WDE) | (0<<WDP3) | (1<<WDP2) | (1<<WDP1) | (1<<WDP0)
		out WDTCSR, temp

;---------- SREG  ,       
		pop temp;-------- 
		out sreg, temp ; Restore SREG
		pop temp
		ret
;***************************************************************************
.exit